// Fremix Gulp Copy Tasks

var gulp = require("gulp"),
    router = require("front-router"),
    processhtml = require("gulp-processhtml"),
    html2js = require("gulp-ng-html2js"),
    concat = require("gulp-concat");

// Copies static files from location to build
gulp.task('copy', ['copy:static', 'copy:pages']);
gulp.task('copy:static', function () {
    var docsHtml = [
        '!./docs/*.*',
        './docs/**/*.*',
        '!./docs/pages/**/*.*',
        '!./docs/assets/{scss,js}/**/*.*'
    ];

    gulp.src(docsHtml, {base: './docs/'})
        .pipe(gulp.dest('build'))

    gulp.src('bower_components/font-awesome/fonts/**/*')
        .pipe(gulp.dest('build/assets/fonts/font-awesome/'))

    return gulp.src('bower_components/foundation-apps/iconic/**/*')
        .pipe(gulp.dest('build/assets/img/iconic/'))
});
gulp.task('copy:pages', function () {
    var pages = [
        './docs/*.html',
        './docs/pages/**/*.html',
    ];
    return gulp.src(pages, {base: './docs/'})
        .pipe(router({
            path: 'docs/assets/js/routes.js',
            root: 'docs'
        }))
        .pipe(processhtml({
            "process": true,
            "environment": "dev",
            "data": {
                "title": "(Development Mode)",
                "message": "We are in development mode",
                "comment": "These comments will get removed in production mode!"
            }
        }))
        .pipe(gulp.dest('build'))
});
gulp.task('copy:html2js', function () {
    return gulp.src("bower_components/foundation-apps/js/angular/components/**/*.html")
        .pipe(html2js({
            "moduleName": "foundation.templates",
            "prefix": "components/"
        }))
        .pipe(concat("foundation.templates.js"))
        .pipe(gulp.dest("docs/assets/js"));
});

