// Fremix Gulp SASS Tasks

var gulp = require("gulp"),
    sass = require("gulp-sass"),
    autoprefixer = require("gulp-autoprefixer"),
    plumber = require("gulp-plumber"),
    sourcemaps = require("gulp-sourcemaps")
    cleanCSS = require("gulp-clean-css"),
    rename = require("gulp-rename");

var LOAD_PATHS = [
    'libs/scss/',
    'bower_components/'
];
var LINT_PATHS = [];
var COMPATIBILITY = [
    'last 2 versions',
    'ie >= 9',
    'Android >= 2.3'
];

gulp.task('sass', ['sass:fremix', 'sass:docs']);

gulp.task('sass:fremix', function(){
    return gulp.src('libs/scss/fremix.scss')
        .pipe(sourcemaps.init())
        .pipe(sass({
            includePaths: LOAD_PATHS
        }).on('error', sass.logError))
        .pipe(autoprefixer({
            browsers: COMPATIBILITY
        }))
        .pipe(gulp.dest('dist/css'))
        .pipe(cleanCSS({debug: true}, function(details) {
            console.log(details.name + ': ' + details.stats.originalSize);
            console.log(details.name + ': ' + details.stats.minifiedSize);
        }))
        .pipe(rename("fremix.min.css"))
        .pipe(sourcemaps.write('.'))
        .pipe(gulp.dest('dist/css'));
});

// Compiles is scss for fremix docs (Including Fremix itself)
gulp.task('sass:docs', function(){
    return gulp.src('docs/assets/scss/app.scss')
        .pipe(sourcemaps.init())
        .pipe(sass({
            includePaths: LOAD_PATHS
        }).on('error', sass.logError))
        .pipe(autoprefixer({
            browsers: COMPATIBILITY
        }))
        .pipe(sourcemaps.write('.'))
        .pipe(gulp.dest('build/assets/css'))
});